=== modified file 'mystrings/decimal.c'
--- mystrings/decimal.c	2008-08-09 02:54:47 +0000
+++ mystrings/decimal.c	2008-08-10 01:24:02 +0000
@@ -231,7 +231,7 @@
   to->sign= 0;
   if ((intpart= to->intg= (precision - frac)))
   {
-    int firstdigits= intpart % DIG_PER_DEC1;
+    const int firstdigits= intpart % DIG_PER_DEC1;
     if (firstdigits)
       *buf++= powers10[firstdigits] - 1; /* get 9 99 999 ... */
     for(intpart/= DIG_PER_DEC1; intpart; intpart--)
@@ -240,7 +240,7 @@
 
   if ((to->frac= frac))
   {
-    int lastdigits= frac % DIG_PER_DEC1;
+    const int lastdigits= frac % DIG_PER_DEC1;
     for(frac/= DIG_PER_DEC1; frac; frac--)
       *buf++= DIG_MAX;
     if (lastdigits)
@@ -785,7 +785,9 @@
 int
 internal_str2dec(const char *from, decimal_t *to, char **end, bool fixed)
 {
-  const char *s= from, *s1, *endp, *end_of_string= *end;
+  const char *s= from, *s1;
+  char *end_of_string = *end;
+  char *endp;
   int i, intg, frac, error, intg1, frac1;
   dec1 x,*buf;
   sanity(to);
@@ -818,7 +820,7 @@
     endp= s;
   }
 
-  *end= (char*) endp;
+  *end= endp;
 
   if (frac+intg == 0)
     goto fatal_error;
@@ -896,7 +898,7 @@
   if (endp+1 < end_of_string && (*endp == 'e' || *endp == 'E'))
   {
     int str_error;
-    int64_t exponent= my_strtoll10(endp+1, (char**) &end_of_string,
+    const int64_t exponent= my_strtoll10(endp+1, (char**) &end_of_string,
                                     &str_error);
 
     if (end_of_string != endp +1)               /* If at least one digit */

=== modified file 'notes.textile'
--- notes.textile	2008-08-09 23:47:36 +0000
+++ notes.textile	2008-08-10 01:24:02 +0000
@@ -8,4 +8,6 @@
 The const uchar *packet into net_real_write() is wrong.  We free
 the packet, so it is not const.
 
+The const uchar *key in _mi_record_pos is wrong.
+
 Work on getting ccache running.

=== modified file 'storage/myisam/myisampack.h'
--- storage/myisam/myisampack.h	2008-08-03 19:34:21 +0000
+++ storage/myisam/myisampack.h	2008-08-10 01:24:02 +0000
@@ -24,58 +24,58 @@
 #define mi_sint1korr(A) ((int8_t)(*A))
 #define mi_uint1korr(A) ((uint8_t)(*A))
 
-#define mi_sint2korr(A) ((int16_t) (((int16_t) (((uchar*) (A))[1])) +\
-                                  ((int16_t) ((int16_t) ((char*) (A))[0]) << 8)))
-#define mi_sint3korr(A) ((int32_t) (((((uchar*) (A))[0]) & 128) ? \
+#define mi_sint2korr(A) ((int16_t) (((int16_t) (((const uchar*) (A))[1])) +\
+                                  ((int16_t) ((int16_t) ((const char*) (A))[0]) << 8)))
+#define mi_sint3korr(A) ((int32_t) (((((const uchar*) (A))[0]) & 128) ? \
                                   (((uint32_t) 255L << 24) | \
-                                   (((uint32_t) ((uchar*) (A))[0]) << 16) |\
-                                   (((uint32_t) ((uchar*) (A))[1]) << 8) | \
-                                   ((uint32_t) ((uchar*) (A))[2])) : \
-                                  (((uint32_t) ((uchar*) (A))[0]) << 16) |\
-                                  (((uint32_t) ((uchar*) (A))[1]) << 8) | \
-                                  ((uint32_t) ((uchar*) (A))[2])))
-#define mi_sint4korr(A) ((int32_t) (((int32_t) (((uchar*) (A))[3])) +\
-                                  ((int32_t) (((uchar*) (A))[2]) << 8) +\
-                                  ((int32_t) (((uchar*) (A))[1]) << 16) +\
-                                  ((int32_t) ((int16_t) ((char*) (A))[0]) << 24)))
+                                   (((uint32_t) ((const uchar*) (A))[0]) << 16) |\
+                                   (((uint32_t) ((const uchar*) (A))[1]) << 8) | \
+                                   ((uint32_t) ((const uchar*) (A))[2])) : \
+                                  (((uint32_t) ((const uchar*) (A))[0]) << 16) |\
+                                  (((uint32_t) ((const uchar*) (A))[1]) << 8) | \
+                                  ((uint32_t) ((const uchar*) (A))[2])))
+#define mi_sint4korr(A) ((int32_t) (((int32_t) (((const uchar*) (A))[3])) +\
+                                  ((int32_t) (((const uchar*) (A))[2]) << 8) +\
+                                  ((int32_t) (((const uchar*) (A))[1]) << 16) +\
+                                  ((int32_t) ((int16_t) ((const char*) (A))[0]) << 24)))
 #define mi_sint8korr(A) ((int64_t) mi_uint8korr(A))
-#define mi_uint2korr(A) ((uint16_t) (((uint16_t) (((uchar*) (A))[1])) +\
-                                   ((uint16_t) (((uchar*) (A))[0]) << 8)))
-#define mi_uint3korr(A) ((uint32_t) (((uint32_t) (((uchar*) (A))[2])) +\
-                                   (((uint32_t) (((uchar*) (A))[1])) << 8) +\
-                                   (((uint32_t) (((uchar*) (A))[0])) << 16)))
-#define mi_uint4korr(A) ((uint32_t) (((uint32_t) (((uchar*) (A))[3])) +\
-                                   (((uint32_t) (((uchar*) (A))[2])) << 8) +\
-                                   (((uint32_t) (((uchar*) (A))[1])) << 16) +\
-                                   (((uint32_t) (((uchar*) (A))[0])) << 24)))
-#define mi_uint5korr(A) ((uint64_t)(((uint32_t) (((uchar*) (A))[4])) +\
-                                    (((uint32_t) (((uchar*) (A))[3])) << 8) +\
-                                    (((uint32_t) (((uchar*) (A))[2])) << 16) +\
-                                    (((uint32_t) (((uchar*) (A))[1])) << 24)) +\
-                                    (((uint64_t) (((uchar*) (A))[0])) << 32))
-#define mi_uint6korr(A) ((uint64_t)(((uint32_t) (((uchar*) (A))[5])) +\
-                                    (((uint32_t) (((uchar*) (A))[4])) << 8) +\
-                                    (((uint32_t) (((uchar*) (A))[3])) << 16) +\
-                                    (((uint32_t) (((uchar*) (A))[2])) << 24)) +\
-                        (((uint64_t) (((uint32_t) (((uchar*) (A))[1])) +\
-                                    (((uint32_t) (((uchar*) (A))[0]) << 8)))) <<\
-                                     32))
-#define mi_uint7korr(A) ((uint64_t)(((uint32_t) (((uchar*) (A))[6])) +\
-                                    (((uint32_t) (((uchar*) (A))[5])) << 8) +\
-                                    (((uint32_t) (((uchar*) (A))[4])) << 16) +\
-                                    (((uint32_t) (((uchar*) (A))[3])) << 24)) +\
-                        (((uint64_t) (((uint32_t) (((uchar*) (A))[2])) +\
-                                    (((uint32_t) (((uchar*) (A))[1])) << 8) +\
-                                    (((uint32_t) (((uchar*) (A))[0])) << 16))) <<\
-                                     32))
-#define mi_uint8korr(A) ((uint64_t)(((uint32_t) (((uchar*) (A))[7])) +\
-                                    (((uint32_t) (((uchar*) (A))[6])) << 8) +\
-                                    (((uint32_t) (((uchar*) (A))[5])) << 16) +\
-                                    (((uint32_t) (((uchar*) (A))[4])) << 24)) +\
-                        (((uint64_t) (((uint32_t) (((uchar*) (A))[3])) +\
-                                    (((uint32_t) (((uchar*) (A))[2])) << 8) +\
-                                    (((uint32_t) (((uchar*) (A))[1])) << 16) +\
-                                    (((uint32_t) (((uchar*) (A))[0])) << 24))) <<\
+#define mi_uint2korr(A) ((uint16_t) (((uint16_t) (((const uchar*) (A))[1])) +\
+                                   ((uint16_t) (((const uchar*) (A))[0]) << 8)))
+#define mi_uint3korr(A) ((uint32_t) (((uint32_t) (((const uchar*) (A))[2])) +\
+                                   (((uint32_t) (((const uchar*) (A))[1])) << 8) +\
+                                   (((uint32_t) (((const uchar*) (A))[0])) << 16)))
+#define mi_uint4korr(A) ((uint32_t) (((uint32_t) (((const uchar*) (A))[3])) +\
+                                   (((uint32_t) (((const uchar*) (A))[2])) << 8) +\
+                                   (((uint32_t) (((const uchar*) (A))[1])) << 16) +\
+                                   (((uint32_t) (((const uchar*) (A))[0])) << 24)))
+#define mi_uint5korr(A) ((uint64_t)(((uint32_t) (((const uchar*) (A))[4])) +\
+                                    (((uint32_t) (((const uchar*) (A))[3])) << 8) +\
+                                    (((uint32_t) (((const uchar*) (A))[2])) << 16) +\
+                                    (((uint32_t) (((const uchar*) (A))[1])) << 24)) +\
+                                    (((uint64_t) (((const uchar*) (A))[0])) << 32))
+#define mi_uint6korr(A) ((uint64_t)(((uint32_t) (((const uchar*) (A))[5])) +\
+                                    (((uint32_t) (((const uchar*) (A))[4])) << 8) +\
+                                    (((uint32_t) (((const uchar*) (A))[3])) << 16) +\
+                                    (((uint32_t) (((const uchar*) (A))[2])) << 24)) +\
+                        (((uint64_t) (((uint32_t) (((const uchar*) (A))[1])) +\
+                                    (((uint32_t) (((const uchar*) (A))[0]) << 8)))) <<\
+                                     32))
+#define mi_uint7korr(A) ((uint64_t)(((uint32_t) (((const uchar*) (A))[6])) +\
+                                    (((uint32_t) (((const uchar*) (A))[5])) << 8) +\
+                                    (((uint32_t) (((const uchar*) (A))[4])) << 16) +\
+                                    (((uint32_t) (((const uchar*) (A))[3])) << 24)) +\
+                        (((uint64_t) (((uint32_t) (((const uchar*) (A))[2])) +\
+                                    (((uint32_t) (((const uchar*) (A))[1])) << 8) +\
+                                    (((uint32_t) (((const uchar*) (A))[0])) << 16))) <<\
+                                     32))
+#define mi_uint8korr(A) ((uint64_t)(((uint32_t) (((const uchar*) (A))[7])) +\
+                                    (((uint32_t) (((const uchar*) (A))[6])) << 8) +\
+                                    (((uint32_t) (((const uchar*) (A))[5])) << 16) +\
+                                    (((uint32_t) (((const uchar*) (A))[4])) << 24)) +\
+                        (((uint64_t) (((uint32_t) (((const uchar*) (A))[3])) +\
+                                    (((uint32_t) (((const uchar*) (A))[2])) << 8) +\
+                                    (((uint32_t) (((const uchar*) (A))[1])) << 16) +\
+                                    (((uint32_t) (((const uchar*) (A))[0])) << 24))) <<\
                                     32))
 
 /* This one is for uniformity */
@@ -126,16 +126,16 @@
 
 #ifdef WORDS_BIGENDIAN
 
-#define mi_float4store(T,A) { ((uchar*) (T))[0]= ((uchar*) &A)[0];\
-                              ((uchar*) (T))[1]= ((uchar*) &A)[1];\
-                              ((uchar*) (T))[2]= ((uchar*) &A)[2];\
-                              ((uchar*) (T))[3]= ((uchar*) &A)[3]; }
+#define mi_float4store(T,A) { ((uchar*) (T))[0]= ((const uchar*) &A)[0];\
+                              ((uchar*) (T))[1]= ((const uchar*) &A)[1];\
+                              ((uchar*) (T))[2]= ((const uchar*) &A)[2];\
+                              ((uchar*) (T))[3]= ((const uchar*) &A)[3]; }
 
 #define mi_float4get(V,M)   { float def_temp;\
-                              ((uchar*) &def_temp)[0]= ((uchar*) (M))[0];\
-                              ((uchar*) &def_temp)[1]= ((uchar*) (M))[1];\
-                              ((uchar*) &def_temp)[2]= ((uchar*) (M))[2];\
-                              ((uchar*) &def_temp)[3]= ((uchar*) (M))[3];\
+                              ((uchar*) &def_temp)[0]= ((const uchar*) (M))[0];\
+                              ((uchar*) &def_temp)[1]= ((const uchar*) (M))[1];\
+                              ((uchar*) &def_temp)[2]= ((const uchar*) (M))[2];\
+                              ((uchar*) &def_temp)[3]= ((const uchar*) (M))[3];\
                               (V)= def_temp; }
 
 #define mi_float8store(T,V) { ((uchar*) (T))[0]= ((uchar*) &V)[0];\

